#include "stdio.h"

#define N 26

int edge[N][N];
int in[N],out[N];
int trace[N];

class DGraph {
  int FindMax_r (int a, int b);
public:
  int n;
  int e[N][N];
  int w[N][N];
  int di[N];
  int way[N];
  int f[N];
  int spo[N];
  int nway;
  
  DGraph (int n_);
  
  void E (int a, int b, int c) { e[a][b]=e[b][a] = c; }
  void D (int a, int b, int c) { e[a][b] = c; }
  
  int E (int a, int b) { return e[a][b] || e[b][a]; }
  int D (int a, int b) { return e[a][b]; }
  
  int FindMin (int a, int b);
  int FindMax (int a, int b);
  int FindMaxNav (int a, int b);
  int FindMinW (int a, int b);
  
  int spojny (int a);
  int spojny_r (int a);
};

DGraph::DGraph (int n_) {
  n=n_;
  for (int x=n; x--;) {
    for (int y=n; y--;) {
      e[x][y]=0;
      w[x][y]=1;
    }
  }
}

int DGraph::spojny_r (int a) {
  int b;
  trace[a]=1;
  for (b=n; b--;) {
    if (!trace[b] && E(a,b)) {
      spojny_r(b);  
    }
  }
}

int DGraph::spojny (int a) {
  for (int i=n; i--;) {
    trace[i]=0;
  }
  spojny_r(a);
}



int euler() {
  int oki=0,oko=0;
  for (int i=N; i--;) {
    if ( (in[i] || out[i]) && !trace[i] ) return 0;
    if (in[i]!=out[i]) {
      if (in[i]==out[i]+1) {
        if (oki) return 0;
	else oki=1;
      }
      else {
        if (in[i]==out[i]-1) {
          if (oko) return 0;
          else oko=1;
        }
        else {
          return 0;
        }
      }
    }
  }
  return 1;
}

int main () {
  int T,NW;
  scanf("%d\n",&T);
  while (T--) {
    DGraph G(N);
    char s[2000];
    int a,b;
    for (int i=0; i<N; i++) {
      in[i]=out[i]=0;
      for (int j=0; j<N; j++) {
        edge[i][j]=0;
      }
    }
    scanf("%d\n",&NW);
    while (NW--) {
      scanf("%s\n",s);
      a=s[0]-'a';
      b=s[strlen(s)-1]-'a';
      edge[a][b]++;
      G.D(a,b,1);
      out[a]++;
      in[b]++;
    }
    for (a=0; a<N; a++) {
      if (in[a] || out[a]) break;
    }
    G.spojny(a);
    if (euler())
      printf("Ordering is possible.\n");
    else
      printf("The door cannot be opened.\n");
  }
  return 0;
}

